//
// Copyright (C) 2001 Fabio Lopiano <flopiano@bigfoot.com>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <iostream>
                      
#include "buffer.h"

//--------------------------------------------------------------

Buffer::Buffer() 
{
    theRep = new Rep();
}

//--------------------------------------------------------------

Buffer::Buffer (size_t aSize)
{ 
    theRep = new Rep(aSize); 
}
    
//--------------------------------------------------------------

Buffer:: Buffer (const char *aCharBuffer, size_t aSize)
{ 
    theRep = new Rep(aSize) ; 
    memcpy( theRep->buffer(), aCharBuffer, aSize); 
}

//--------------------------------------------------------------

Buffer:: Buffer (const unsigned char *aCharBuffer, size_t aSize)
{ 
    theRep = new Rep(aSize) ; 
    memcpy( theRep->buffer(), aCharBuffer, aSize); 
}

//--------------------------------------------------------------

Buffer:: Buffer (const Buffer &aBuffer) 
{ 
    theRep = aBuffer.theRep->copy(); 
}

//--------------------------------------------------------------

bool Buffer::operator ==(const Buffer &aBuffer) const 
{
     if (theRep == aBuffer.theRep) 
         return true;
     if (size() != aBuffer.size())
         return false;
     return (memcmp(theRep->const_buffer(),
                    aBuffer.theRep->const_buffer(),
                    size()) == 0);
 }

//--------------------------------------------------------------

Buffer & Buffer::operator += (const Buffer &aBuffer)
{
     if(aBuffer.size() == 0) return *this;
     if(size() == 0)  return *this = aBuffer;

     Buffer tmp( *this );
     theRep = theRep->resize( size() + aBuffer.size() );
     memcpy( theRep->buffer() , tmp.theRep->const_buffer(), tmp.size());
     memcpy( theRep->buffer() + tmp.size() ,
             aBuffer.theRep->const_buffer(), aBuffer.size());
     return *this;
}

