// Copyright (C) 2001 Fabio Lopiano <flopiano@bigfoot.com>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#include "buffer.h"
#include "netbuffer.h"
#include "netobject.h"

void NetObject::netCopy(const Buffer &aBuffer) 
{
    NetBuffer nbuf(aBuffer);
    netRead(nbuf);
}

void NetObject::netCopy(const NetObject &anObject)
{
   netCopy(anObject.toBuffer());
}

void NetObject::netClear()
{
    NetBuffer nbuf;  // empty
    netRead(nbuf);   // fill with 0
}

size_t NetObject::netSize()const
{
    NetBuffer nbuf;  // empty
    netWrite(nbuf);  // attempt to write
    return nbuf.bytesWritten(); 
}

bool NetObject::operator==(const NetObject &anObject) const
{
    if (this == &anObject) return true;
    
    return (toBuffer() == anObject.toBuffer());
}

